package dk.raptus.qe;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.util.FloatMath;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class QuadraticEquationActivity extends Activity implements OnClickListener {
   private AlertDialog adAIsZero;
   private EditText etA;
   private EditText etB;
   private EditText etC;   
   private TextView tvRoot1;
   private TextView tvRoot2;

   @Override
   public void onCreate(Bundle savedInstanceState) {
	  super.onCreate(savedInstanceState);
      setContentView(R.layout.main);

      Button buCompute=(Button)findViewById(R.id.buttonCompute);
      buCompute.setOnClickListener(this);      

      Button buAbout=(Button)findViewById(R.id.buttonAbout);
      buAbout.setOnClickListener(this);      
      
      Button buExit=(Button)findViewById(R.id.buttonExit);
      buExit.setOnClickListener(this);
      
      // Prepare the A=0 warning dialog
      adAIsZero=new AlertDialog.Builder(this).create();
      adAIsZero.setButton("OK",new DialogInterface.OnClickListener() {
         public void onClick(DialogInterface dialog,int which) {
         }
      });
      adAIsZero.setIcon(R.drawable.icon);
      adAIsZero.setMessage("\"A\" must of course never be zero!");
      adAIsZero.setTitle("Coefficient error");
      
      etA=(EditText)findViewById(R.id.editTextA);
      etB=(EditText)findViewById(R.id.editTextB);
      etC=(EditText)findViewById(R.id.editTextC);
      tvRoot1=(TextView)findViewById(R.id.textViewRoot1);
      tvRoot2=(TextView)findViewById(R.id.textViewRoot2);
   }

   public void onClick(View v) {
	  double a,b,c,d,e,f,root1,root2;
      String sReal,sImag;
	  switch (v.getId()) {
	     case R.id.buttonCompute:
            try {
	           a=Double.parseDouble(etA.getText().toString());
            }
            catch (NumberFormatException ex) {
               etA.setText("0"); // Insert zero if user didn't type anything
               a=0;
            }
            try {
               b=Double.parseDouble(etB.getText().toString());
            }
            catch (NumberFormatException ex) {
               etB.setText("0"); // Insert zero if user didn't type anything
               b=0;
            }
            try {
               c=Double.parseDouble(etC.getText().toString());
            }
            catch (NumberFormatException ex) {
               etC.setText("0"); // Insert zero if user didn't type anything
               c=0;
            }
            if (a==0) { // If A=0, display a warning
               adAIsZero.show();
               break;
            }
            d=b*b-4*a*c; // Compute discriminant
            if (d>=0) { // Real roots
               e=FloatMath.sqrt((float)d);               
               root1=(-b+e)/(2*a);
               root2=(-b-e)/(2*a);            
               tvRoot1.setText(Double.toString(root1));         
               tvRoot2.setText(Double.toString(root2));
            }
            else { // Complex roots
               e=FloatMath.sqrt(-(float)d);
               sReal=Double.toString(-b/(2*a));
               f=e/(2*a);
               if (f<0) f=-f;
               sImag=Double.toString(f);
               tvRoot1.setText(sReal + "\n+ j" + sImag);                
               tvRoot2.setText(sReal + "\n- j" + sImag);
            }
            break;
	     case R.id.buttonAbout:
            Intent i=new Intent(this,About.class);
            startActivity(i);
	    	break;
	     case R.id.buttonExit:
	    	finish();
	    	break;
         default:
        	break;
	  }
   }
}
